const String templateBegining = """
// GENERATED CODE - DO NOT MODIFY BY HAND
// ignore_for_file: prefer_final_fields, public_member_api_docs, prefer_single_quotes, omit_local_variable_types, unnecessary_this

import 'dart:async';

import 'package:flutter/material.dart';

/// A  class generated by flappy_translator package containing localized strings
class #CLASS_NAME# {
  /// Fields area

  static Map<String, String> _localizedValues;

  /// Values area

""";

const String templateDependContext = """
  #CLASS_NAME#(Locale locale) {
    this._locale = locale;
    _localizedValues = null;
  }

  Locale _locale;

  static #CLASS_NAME# of(BuildContext context) {
    return Localizations.of<#CLASS_NAME#>(context, #CLASS_NAME#);
  }

  String _getText(String key) {
    return _localizedValues[key] ?? '** \$key not found';
  }

  Locale get currentLocale => _locale;

  String get currentLanguage => _locale.languageCode;
""";

const String templateDontDependContext = """
  #CLASS_NAME#(Locale locale) {
    _locale = locale;
    _localizedValues = null;
  }

  static Locale _locale;

  static String _getText(String key) {
    return _localizedValues[key] ?? '** \$key not found';
  }

  static Locale get currentLocale => _locale;

  static String get currentLanguage => _locale.languageCode;
""";

const String templateGetStringDependContext = """

  /// Returns the corresponding string for a given key
  String getString(String key) => _getText(key);
""";

const String templateGetStringDontDependContext = """

  /// Returns the corresponding string for a given key
  static String getString(String key) => _getText(key);
""";

const String templateEnding = """

  static Future<#CLASS_NAME#> load(Locale locale) async {
    final translations = #CLASS_NAME#(locale);
    _localizedValues = _allValues[locale.toString()];
    return translations;
  }
}

class #CLASS_NAME#Delegate extends LocalizationsDelegate<#CLASS_NAME#> {
  const #CLASS_NAME#Delegate();

  /// SupportedLanguages area

  @override
  Future<#CLASS_NAME#> load(Locale locale) => #CLASS_NAME#.load(locale);

  @override
  bool shouldReload(#CLASS_NAME#Delegate old) => false;
}

""";
